searchNodes=[{"ref":"EctoPgGeom.html","title":"EctoPgGeom","type":"module","doc":"A collection of modules allowing Postgres Geometry types to be used in Ecto, via the Postgrex library."},{"ref":"EctoPgGeom.html#geometric_equality/2","title":"EctoPgGeom.geometric_equality/2","type":"macro","doc":"A macro that generates an Ecto fragment which compares the equality of two geometries. Required for testing equality of geometric types such as points and polygons which do not have a functional = operator. To use import EctoPgGeom, only: [geometric_equality: 2] and then you may use in e.g. Ecto query where clauses: geometric_equality(t.point, point)"},{"ref":"EctoPgGeom.Box.html","title":"EctoPgGeom.Box","type":"module","doc":"An Ecto type for boxes. May be used as a field in an Ecto.Schema for automatic use of box data stored in the database: field :box, EctoPgGeom.Box Assigning to a box field can be done either by manually creating a %Postgrex.Box{} struct, or by passing data in the shape of [{x1, y1}, {x2, y2}]. cast/1 and dump/1 will take care of the translation."},{"ref":"EctoPgGeom.Box.html#cast/1","title":"EctoPgGeom.Box.cast/1","type":"function","doc":"Casts the given input to the custom type. This callback is called on external input and can return any type, as long as the dump/1 function is able to convert the returned value into an Ecto native type. There are two situations where this callback is called: When casting values by Ecto.Changeset When passing arguments to Ecto.Query When returning {:error, keyword()}, the returned keyword list will be preserved in the changeset errors, similar to Changeset.add_error/4. Passing a :message key, will override the default message. It is not possible to override the :type key. For {:array, CustomType} or {:map, CustomType} the returned keyword list will be erased and the default error will be shown. Callback implementation for Ecto.Type.cast/1."},{"ref":"EctoPgGeom.Box.html#dump/1","title":"EctoPgGeom.Box.dump/1","type":"function","doc":"Dumps the given term into an Ecto native type. This callback is called with any term that was stored in the struct and it needs to validate them and convert it to an Ecto native type. Callback implementation for Ecto.Type.dump/1."},{"ref":"EctoPgGeom.Box.html#load/1","title":"EctoPgGeom.Box.load/1","type":"function","doc":"Loads the given term into a custom type. This callback is called when loading data from the database and receives an Ecto native type. It can return any type, as long as the dump/1 function is able to convert the returned value back into an Ecto native type. Callback implementation for Ecto.Type.load/1."},{"ref":"EctoPgGeom.Box.html#type/0","title":"EctoPgGeom.Box.type/0","type":"function","doc":"Returns the underlying schema type for the custom type. For example, if you want to provide your own date structures, the type function should return :date. Note this function is not required to return Ecto primitive types, the type is only required to be known by the adapter. Callback implementation for Ecto.Type.type/0."},{"ref":"EctoPgGeom.Circle.html","title":"EctoPgGeom.Circle","type":"module","doc":"An Ecto type for circles. May be used as a field in an Ecto.Schema for automatic use of circle data stored in the database: field :circle, EctoPgGeom.Circle Assigning to a circle field can be done either by manually creating a %Postgrex.Circle{} struct, or by passing data in the shape of {{x, y}, radius}. cast/1 and dump/1 will take care of the translation."},{"ref":"EctoPgGeom.Circle.html#cast/1","title":"EctoPgGeom.Circle.cast/1","type":"function","doc":"Casts the given input to the custom type. This callback is called on external input and can return any type, as long as the dump/1 function is able to convert the returned value into an Ecto native type. There are two situations where this callback is called: When casting values by Ecto.Changeset When passing arguments to Ecto.Query When returning {:error, keyword()}, the returned keyword list will be preserved in the changeset errors, similar to Changeset.add_error/4. Passing a :message key, will override the default message. It is not possible to override the :type key. For {:array, CustomType} or {:map, CustomType} the returned keyword list will be erased and the default error will be shown. Callback implementation for Ecto.Type.cast/1."},{"ref":"EctoPgGeom.Circle.html#dump/1","title":"EctoPgGeom.Circle.dump/1","type":"function","doc":"Dumps the given term into an Ecto native type. This callback is called with any term that was stored in the struct and it needs to validate them and convert it to an Ecto native type. Callback implementation for Ecto.Type.dump/1."},{"ref":"EctoPgGeom.Circle.html#load/1","title":"EctoPgGeom.Circle.load/1","type":"function","doc":"Loads the given term into a custom type. This callback is called when loading data from the database and receives an Ecto native type. It can return any type, as long as the dump/1 function is able to convert the returned value back into an Ecto native type. Callback implementation for Ecto.Type.load/1."},{"ref":"EctoPgGeom.Circle.html#type/0","title":"EctoPgGeom.Circle.type/0","type":"function","doc":"Returns the underlying schema type for the custom type. For example, if you want to provide your own date structures, the type function should return :date. Note this function is not required to return Ecto primitive types, the type is only required to be known by the adapter. Callback implementation for Ecto.Type.type/0."},{"ref":"EctoPgGeom.Line.html","title":"EctoPgGeom.Line","type":"module","doc":"An Ecto type for lines. May be used as a field in an Ecto.Schema for automatic use of line data stored in the database: field :line, EctoPgGeom.Line Assigning to a line field can be done either by manually creating a %Postgrex.Line{} struct, or by passing a {A, B, C} line definition, where Ax + By + C = 0. cast/1 and dump/1 will take care of the translation."},{"ref":"EctoPgGeom.Line.html#cast/1","title":"EctoPgGeom.Line.cast/1","type":"function","doc":"Casts the given input to the custom type. This callback is called on external input and can return any type, as long as the dump/1 function is able to convert the returned value into an Ecto native type. There are two situations where this callback is called: When casting values by Ecto.Changeset When passing arguments to Ecto.Query When returning {:error, keyword()}, the returned keyword list will be preserved in the changeset errors, similar to Changeset.add_error/4. Passing a :message key, will override the default message. It is not possible to override the :type key. For {:array, CustomType} or {:map, CustomType} the returned keyword list will be erased and the default error will be shown. Callback implementation for Ecto.Type.cast/1."},{"ref":"EctoPgGeom.Line.html#dump/1","title":"EctoPgGeom.Line.dump/1","type":"function","doc":"Dumps the given term into an Ecto native type. This callback is called with any term that was stored in the struct and it needs to validate them and convert it to an Ecto native type. Callback implementation for Ecto.Type.dump/1."},{"ref":"EctoPgGeom.Line.html#load/1","title":"EctoPgGeom.Line.load/1","type":"function","doc":"Loads the given term into a custom type. This callback is called when loading data from the database and receives an Ecto native type. It can return any type, as long as the dump/1 function is able to convert the returned value back into an Ecto native type. Callback implementation for Ecto.Type.load/1."},{"ref":"EctoPgGeom.Line.html#type/0","title":"EctoPgGeom.Line.type/0","type":"function","doc":"Returns the underlying schema type for the custom type. For example, if you want to provide your own date structures, the type function should return :date. Note this function is not required to return Ecto primitive types, the type is only required to be known by the adapter. Callback implementation for Ecto.Type.type/0."},{"ref":"EctoPgGeom.LineSegment.html","title":"EctoPgGeom.LineSegment","type":"module","doc":"An Ecto type for line segments. May be used as a field in an Ecto.Schema for automatic use of line segment data stored in the database: field :line, EctoPgGeom.LineSegment Assigning to a line segment field can be done either by manually creating a %Postgrex.LineSegment{} struct, or by passing a pair of points in a list: [{x1, y1, {x2, y2}]. cast/1 and dump/1 will take care of the translation."},{"ref":"EctoPgGeom.LineSegment.html#cast/1","title":"EctoPgGeom.LineSegment.cast/1","type":"function","doc":"Casts the given input to the custom type. This callback is called on external input and can return any type, as long as the dump/1 function is able to convert the returned value into an Ecto native type. There are two situations where this callback is called: When casting values by Ecto.Changeset When passing arguments to Ecto.Query When returning {:error, keyword()}, the returned keyword list will be preserved in the changeset errors, similar to Changeset.add_error/4. Passing a :message key, will override the default message. It is not possible to override the :type key. For {:array, CustomType} or {:map, CustomType} the returned keyword list will be erased and the default error will be shown. Callback implementation for Ecto.Type.cast/1."},{"ref":"EctoPgGeom.LineSegment.html#dump/1","title":"EctoPgGeom.LineSegment.dump/1","type":"function","doc":"Dumps the given term into an Ecto native type. This callback is called with any term that was stored in the struct and it needs to validate them and convert it to an Ecto native type. Callback implementation for Ecto.Type.dump/1."},{"ref":"EctoPgGeom.LineSegment.html#load/1","title":"EctoPgGeom.LineSegment.load/1","type":"function","doc":"Loads the given term into a custom type. This callback is called when loading data from the database and receives an Ecto native type. It can return any type, as long as the dump/1 function is able to convert the returned value back into an Ecto native type. Callback implementation for Ecto.Type.load/1."},{"ref":"EctoPgGeom.LineSegment.html#type/0","title":"EctoPgGeom.LineSegment.type/0","type":"function","doc":"Returns the underlying schema type for the custom type. For example, if you want to provide your own date structures, the type function should return :date. Note this function is not required to return Ecto primitive types, the type is only required to be known by the adapter. Callback implementation for Ecto.Type.type/0."},{"ref":"EctoPgGeom.Path.html","title":"EctoPgGeom.Path","type":"module","doc":"An Ecto type for paths. May be used as a field in an Ecto.Schema for automatic use of path data stored in the database: field :line, EctoPgGeom.Path Assigning to a path field can be done either by manually creating a %Postgrex.Path{} struct, or by passing a list of points for a closed path or a tuple of points for an open path. cast/1 and dump/1 will take care of the translation."},{"ref":"EctoPgGeom.Path.html#cast/1","title":"EctoPgGeom.Path.cast/1","type":"function","doc":"Casts the given input to the custom type. This callback is called on external input and can return any type, as long as the dump/1 function is able to convert the returned value into an Ecto native type. There are two situations where this callback is called: When casting values by Ecto.Changeset When passing arguments to Ecto.Query When returning {:error, keyword()}, the returned keyword list will be preserved in the changeset errors, similar to Changeset.add_error/4. Passing a :message key, will override the default message. It is not possible to override the :type key. For {:array, CustomType} or {:map, CustomType} the returned keyword list will be erased and the default error will be shown. Callback implementation for Ecto.Type.cast/1."},{"ref":"EctoPgGeom.Path.html#dump/1","title":"EctoPgGeom.Path.dump/1","type":"function","doc":"Dumps the given term into an Ecto native type. This callback is called with any term that was stored in the struct and it needs to validate them and convert it to an Ecto native type. Callback implementation for Ecto.Type.dump/1."},{"ref":"EctoPgGeom.Path.html#load/1","title":"EctoPgGeom.Path.load/1","type":"function","doc":"Loads the given term into a custom type. This callback is called when loading data from the database and receives an Ecto native type. It can return any type, as long as the dump/1 function is able to convert the returned value back into an Ecto native type. Callback implementation for Ecto.Type.load/1."},{"ref":"EctoPgGeom.Path.html#type/0","title":"EctoPgGeom.Path.type/0","type":"function","doc":"Returns the underlying schema type for the custom type. For example, if you want to provide your own date structures, the type function should return :date. Note this function is not required to return Ecto primitive types, the type is only required to be known by the adapter. Callback implementation for Ecto.Type.type/0."},{"ref":"EctoPgGeom.Point.html","title":"EctoPgGeom.Point","type":"module","doc":"An Ecto type for points. May be used as a field in an Ecto.Schema for automatic use of point data stored in the database: field :line, EctoPgGeom.Point Assigning to a point field can be done either by manually creating a %Postgrex.Point{} struct, or by passing an {x, y} point tuple. cast/1 and dump/1 will take care of the translation. To create equality checks in queries, use the EctoPgGeom.geometric_equality/2 macro."},{"ref":"EctoPgGeom.Point.html#cast/1","title":"EctoPgGeom.Point.cast/1","type":"function","doc":"Casts the given input to the custom type. This callback is called on external input and can return any type, as long as the dump/1 function is able to convert the returned value into an Ecto native type. There are two situations where this callback is called: When casting values by Ecto.Changeset When passing arguments to Ecto.Query When returning {:error, keyword()}, the returned keyword list will be preserved in the changeset errors, similar to Changeset.add_error/4. Passing a :message key, will override the default message. It is not possible to override the :type key. For {:array, CustomType} or {:map, CustomType} the returned keyword list will be erased and the default error will be shown. Callback implementation for Ecto.Type.cast/1."},{"ref":"EctoPgGeom.Point.html#dump/1","title":"EctoPgGeom.Point.dump/1","type":"function","doc":"Dumps the given term into an Ecto native type. This callback is called with any term that was stored in the struct and it needs to validate them and convert it to an Ecto native type. Callback implementation for Ecto.Type.dump/1."},{"ref":"EctoPgGeom.Point.html#load/1","title":"EctoPgGeom.Point.load/1","type":"function","doc":"Loads the given term into a custom type. This callback is called when loading data from the database and receives an Ecto native type. It can return any type, as long as the dump/1 function is able to convert the returned value back into an Ecto native type. Callback implementation for Ecto.Type.load/1."},{"ref":"EctoPgGeom.Point.html#type/0","title":"EctoPgGeom.Point.type/0","type":"function","doc":"Returns the underlying schema type for the custom type. For example, if you want to provide your own date structures, the type function should return :date. Note this function is not required to return Ecto primitive types, the type is only required to be known by the adapter. Callback implementation for Ecto.Type.type/0."},{"ref":"EctoPgGeom.Polygon.html","title":"EctoPgGeom.Polygon","type":"module","doc":"An Ecto type for polygon. May be used as a field in an Ecto.Schema for automatic use of polygon data stored in the database: field :line, EctoPgGeom.Polygon Assigning to a polygon field can be done either by manually creating a %Postgrex.Polygon{} struct, or by passing a list of points, such as [{1, 2}, {30, 40}, {14, 15}]. cast/1 and dump/1 will take care of the translation. To create equality checks in queries, use the EctoPgGeom.geometric_equality/2 macro."},{"ref":"EctoPgGeom.Polygon.html#cast/1","title":"EctoPgGeom.Polygon.cast/1","type":"function","doc":"Casts the given input to the custom type. This callback is called on external input and can return any type, as long as the dump/1 function is able to convert the returned value into an Ecto native type. There are two situations where this callback is called: When casting values by Ecto.Changeset When passing arguments to Ecto.Query When returning {:error, keyword()}, the returned keyword list will be preserved in the changeset errors, similar to Changeset.add_error/4. Passing a :message key, will override the default message. It is not possible to override the :type key. For {:array, CustomType} or {:map, CustomType} the returned keyword list will be erased and the default error will be shown. Callback implementation for Ecto.Type.cast/1."},{"ref":"EctoPgGeom.Polygon.html#dump/1","title":"EctoPgGeom.Polygon.dump/1","type":"function","doc":"Dumps the given term into an Ecto native type. This callback is called with any term that was stored in the struct and it needs to validate them and convert it to an Ecto native type. Callback implementation for Ecto.Type.dump/1."},{"ref":"EctoPgGeom.Polygon.html#load/1","title":"EctoPgGeom.Polygon.load/1","type":"function","doc":"Loads the given term into a custom type. This callback is called when loading data from the database and receives an Ecto native type. It can return any type, as long as the dump/1 function is able to convert the returned value back into an Ecto native type. Callback implementation for Ecto.Type.load/1."},{"ref":"EctoPgGeom.Polygon.html#to_point_structs/2","title":"EctoPgGeom.Polygon.to_point_structs/2","type":"function","doc":""},{"ref":"EctoPgGeom.Polygon.html#type/0","title":"EctoPgGeom.Polygon.type/0","type":"function","doc":"Returns the underlying schema type for the custom type. For example, if you want to provide your own date structures, the type function should return :date. Note this function is not required to return Ecto primitive types, the type is only required to be known by the adapter. Callback implementation for Ecto.Type.type/0."}]